#ifndef EDGE_HH_
#define EDGE_HH_

#include <QGraphicsItem>
#include <QStringList>

class node;

//! [0]
class edge : public QGraphicsItem
{
public:
    edge(node *sourcenode, node *destnode, const QString& reason);
	~edge();

    node *sourcenode() const;
    node *destnode() const;

    void adjust();
	void add_reason(const QString&);
	void remove_reason(const QString&);
	size_t number_reason() const { return reasons.size(); }

    enum { Type = UserType + 2 };
    int type() const { return Type; }

	int min_size() { return bounding_text.width(); }
    
protected:
    QRectF boundingRect() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

private:
	void adjust_reason();
    
private:
    node *source, *dest;
	QStringList reasons;
	QString reason_txt;
	QRectF bounding_text;

    QPointF sourcePoint;
    QPointF destPoint;
    qreal arrowSize;
};

#endif
