#include <QApplication>
#include <QtGui>
#include <QtGlobal>

#include <graph_widget.hh>
#include <hyper_live_node.hh>
#include <hyper_replay_node.hh>
		  
int main(int argc, char *argv[])
{
	QApplication app(argc, argv);

	graph_widget widget;
	hyper_live_node logger;

	qsrand(QTime::currentTime().msec());

	QObject::connect(&logger, SIGNAL(new_agent(const QString&)),
					 &widget, SLOT(add_node(const QString&)));
	QObject::connect(&logger, SIGNAL(remove_agent(const QString&)),
					 &widget, SLOT(remove_node(const QString&)));
	QObject::connect(&logger, SIGNAL(add_link(const QString&, const QString&, const QString&, const QString&)),
					 &widget, SLOT(add_connection(const QString&, const QString&, const QString&, const QString&)));
	QObject::connect(&logger, SIGNAL(remove_link(const QString&)),
					 &widget, SLOT(remove_connection(const QString&)));

	logger.start();
	widget.show();

	return app.exec();
}
