#ifndef NODE_HH_
#define NODE_HH_

#include <QGraphicsItem>
#include <QFont>

class graph_widget;
class edge;
QT_BEGIN_NAMESPACE
class QGraphicsSceneMouseEvent;
QT_END_NAMESPACE

class node : public QGraphicsItem
{
public:
    node(const QString&, graph_widget* graphWidget);

    enum { Type = UserType + 1 };
    int type() const { return Type; }

	const QString& name() { return name_; }

    void calculateForces();
    bool advance();

    QRectF boundingRect() const;
    QPainterPath shape() const;
    void paint(QPainter *painter, const QStyleOptionGraphicsItem *option, QWidget *widget);

	void add_edge(edge*);
	void remove_edge(edge*);
	const QList<edge*>& edges() const;

protected:
    QVariant itemChange(GraphicsItemChange change, const QVariant &value);

    void mousePressEvent(QGraphicsSceneMouseEvent *event);
    void mouseReleaseEvent(QGraphicsSceneMouseEvent *event);
    
private:
    QPointF newPos;
	QFont font;
	QString name_;
	QList<edge*> edgeList;
    graph_widget *graph;

	int width, height;
};

#endif
