#ifndef REPLAY_WIDGET_HH_
#define REPLAY_WIDGET_HH_

#include <QWidget>
#include <QSlider>
#include <QToolButton>

#include <graph_widget.hh>
#include <hyper_replay_node.hh>

class ReplayWidget : public QWidget {
	Q_OBJECT
	
	private:
		enum state_ {
			IDLE, PLAY, PAUSE, STOP
		};

		state_ s;
		void update_buttons();
		QToolButton* playButton, *pauseButton;

		bool slider_user_interaction;
		QSlider *event_slider;

		graph_widget* graph;
		hyper_replay_node* node;

	public:
		ReplayWidget(QWidget *parent = 0);
		ReplayWidget(const std::string& filename, QWidget *parent = 0);
	
	private:
		void init();
		void open_log(const std::string& filename);

	private slots:
		void open();
		void start();
		void pause(bool);

		void new_event(const QString& s);
		void new_event(const QString&, const QString&, const QString&, const QString&);

		void sliderPressed();
		void sliderReleased();
		void sliderValueChanged(int);

};

#endif /* REPLAY_WIDGET_HH_ */
